
	section .text
	align  1

	global _crc_generic

_crc_generic      ; word crc_generic(byte *p, word iv, word poly, word cc);

	pshm z
	tsz           ; poly in 6,z and cc in 8,z
	xgex          ; p in X
	              ; iv in D, seed of CRC, already in position
L1
	eorb 0,x      ; crc ^= *p++
	aix  #+1

	REPT 8        ; 6 bytes, 8 times, 48 total
	lsrd
	bcc  * + 4    ; skip eord
	eord 6,z      ; poly
	ENDR

	decw 8,z      ; while (--cc)
	bne  L1

	pulm z
	rts

	;
	; martyfeldman variation
	;

	global _crc_generic_RMNC

_crc_generic_RMNC ; w c_g_R(word cc_E, word iv_D, byte *p, word poly)
	pshm z
	tsz

	ldx  6,z   ; p
L9
	stab 6,z   ; use 'p' as scratch for old crc
	tab
	clra
	comd
	eorb 0,x
	aix  #+1

	REPT 8
	lsrd
	bcc  * + 4 ; skip eord if no carry
	eord 8,z   ; poly
	ENDR

	eora 6,z   ; one round of crc done.

	aie  #-1
	bne  L9

	pulm z
	rts

	;
	;  Simple bytewide sum, 16-bit result
	;

	global _checksum

_checksum

	xgex           ; address
	xgdy           ; bytecount
	clrd           ; accu
L2
	addb 0,x
	adca # 0
	aix  #+1
	aiy  #-1
	bne  L2

	rts

unused MACRO

	global _parity ;  1-bits in given area, 16-bit result

_parity

	xgex           ; address
	xgdy           ; bytecount
	clre
L3
	ldab 0,x
	lsrb           ; assume MSbit 0 more often than 1
L4
	adce # 0       ; nasty to have doubleword op here XXX
	lsrb
	bne  L4        ; still 1-bits in there
	adce # 0       ; not forgetting the last 1-bit

	aix  #+1
	aiy  #-1
	bne  L3

	ted
	rts

	global _parity ;  1-bits in given area, 8-bit result

_parity

	xgex           ; address
	xgdy           ; bytecount
	clrb
L3
	ldaa 0,x
	lsra           ; assume MSbit 0 more often than 1
L4
	adcb # 0
	lsra
	bne  L4        ; still 1-bits in there
	adcb # 0       ; not forgetting the last 1-bit

	aix  #+1
	aiy  #-1
	bne  L3

	rts            ; A already clear

	ENDM

	end

