
#define DEBUG  1
#define STATIC static

#if DEBUG
extern int debug;
#else
#define debug 0
#endif

typedef unsigned char  byte;
typedef unsigned char  bool;
typedef unsigned short word;
typedef unsigned long  stamp;
typedef unsigned long  dword;

#define WORD_MAX    65535
#define SHORT_MIN (-32768)
#define SHORT_MAX (+32767)

void now(stamp *);
bool time_past(stamp);
word msec_since(stamp *);
void future_sec(stamp *, word sec);
void future_msec(stamp *, word msec);

word  bolt();   /* same thing, two widths */
dword uptime();

void delay_ms(word millisec);

word peekw(word offset, word segment);

word read_AN(word ANx); /* AN0...7, result in 10 MSbits, LSbits zero */

word read_RSSI();        /* not smoothed */
word read_rssi_avg();    /* smoothed */
bool busy_channel();     /* hardware squelch aka BUSY */

/* XXX pin(0) is cpu pin 0, D25 pin +V XXX konfutseus */

void CTS1_pin(word set);
void CTS2_pin(word dont_clr);
void DCD1_pin(word set);
void DCD2_pin(word dont_clr);
void DSR1_pin(word set);
void DSR2_pin(word set);

bool DTR1_pin(void);
bool DTR2_pin(void);
bool RTS1_pin(void);
bool RTS2_pin(void);

extern const word word_bitmask[];
extern const byte byte_bitmask[];
extern const byte hex_characters[];

#define spl0() asm("andp #0FF1Fh")
#define spl7() asm("orp  #000E0h")

word  ld_word_intel(void *);
dword ld_dword_intel(void *);
short ld_short_intel(void *);
long  ld_long_intel(void *);

void link_list_append(void *, void *); /* 'next' must be first in struct */

void ASLx(dword *, word nbits);
void LSRx(dword *, word nbits);

word RRC_byte(word); /* using 'word' seems odd, but helps cc a lot */
word RLC_byte(word);
word ASL_word(word, word nbits);
word LSR_word(word, word nbits);

word REM(word *inout, word divisor);
word DIV(word, word, word *rem);
word EDIV(long, word, word *rem);
long EDIVx(long, word, word *rem);

long EMUL(word, word);
long EMULx(long, word);
long FMULS(word, word);

word muldiv(word value, word mul, word div);

void SCALE16(long *, long *); /* scale 1st argument by 2nd */
void SCALE24(long *, long *);
void SCALE32(long *, long *);

void SCALE32_signed(long *, long *);

#define FALSE 0
#define TRUE  1
#define NULL  ((void *) 0)
#define EOF   (-1)

#define BLANK    ' '
#define COMMA    ','
#define DOT      '.'
#define TICK     '\''
#define BACKTICK '`'

#define STR_DEGREE "\260"

#define __SIZEOF(arr) (sizeof(arr) / sizeof((arr)[0]))
#define __ENDOF(arr)  ((arr) + __SIZEOF(arr))

#define __offsetof(typ, fld) ((word) &((typ *)0)->fld)

/* ((c) - first <= last - first) creates worse code.
 * live with the macro danger */

#define __isdigit(c) ((c) >= '0' && (c) <= '9')
#define __isupper(c) ((c) >= 'A' && (c) <= 'Z')
#define __islower(c) ((c) >= 'a' && (c) <= 'z')
#define __isprint(c) ((c) >= ' ' && (c) < 0x7F)

/* these only if input is letter, or result is tested to be letter */

#define __tolower(c) ((c) | 0x20)
#define __toupper(c) ((c) & ~0x20)

byte *prompt(byte *);
bool more(int *);

int  printf(char *, ...); /* ... puts all args on stack */
void putchar(byte);
byte getchar();
void doh(char *what);
void eol(), blank();
word isqrt(dword);
word ihypot(word, word);
word iatan2(long, long);

char *itoa(char *buf, int bsize, word i);
char *ltoa(char *buf, int bsize, dword l);

bool  isdigit(byte);
bool  isalnum(byte);
bool  isspace(byte);
bool  wildmat(byte *pat, byte *);

int   substrcmp(byte *unk, char *substr);
int   substrcasecmp(byte *unk, char *uc_substr);
byte  toupper(byte);
byte  tolower(byte);
int   strcasecmp(byte *, byte *);
int   strcmp(byte *, byte *);
int   strncmp(byte *, byte *, int size);
byte *strcpyx(byte *, byte *);
byte *strcatx(byte *, byte *);
void  strupper(byte *);
void  strlower(byte *);
int   strlen(byte *);
void  strncpyx(byte *dst, byte *src, int size);
byte *index(byte *str, byte c);
byte *strend(byte *str);
byte *memchr(byte *buf, byte c, word buflen);
byte *strstr(byte *str, byte *substr);
void  bzero(void *, int cc);
void  bcopy(void *vsrc, void *vdst, int cc);
int   bcmp(void *, void *, int cc);

void print_byte(byte);
void print_word(word);
void print_dword(dword *);
void print_buf(void *, int cc);
void print_string(byte *);
void print_short(word);
void print_short_N(word, short width);
void print_signed_short(short);
void print_signed_long(long);

word atow(const byte *str);
void atol_signed(long *, char *str);

word  abs(short);
dword labs(long);
long  lneg(long);
void  lnegate(long *);

byte *sprint_u(byte *, word);
byte *sprint_i(byte *, short);
byte *sprint_02u(byte *, word);
byte *sprint_03u(byte *, word);
byte *sprint_04u(byte *, word);
byte *sprint_05u(byte *, word);

byte *sprint_02X(byte *, byte);

void sprint_03d_signed(byte *, short);
void sprint_06Lu(byte *, dword *);
void sprint_010Lu(byte *, dword *);
void sprint_lat(byte *, long *);
void sprint_lon(byte *, long *);

word sscan_num(byte *str, word len);
word sscan_hex(byte *str, word len);

word sscan_02u(byte *); /* byte really */
word sscan_03u(byte *);

