
	section .bss
	align 1

bins    ds.b 40     ; 16 16bit bins and 4 more for wrap
numsamp ds.w 1
avg     ds.w 1

	section .text
	align 1

	global _wind_direction_consavg ; word avg (word slot)

_wind_direction_consavg

	pshm  z
	ais   #-2
	tsz

	ldx   # bins       ; p = bins
	asle
	incw  e,x          ; bins[slot]++

	ldd   numsamp
	addd  # 1
	std   numsamp
	cpd   # 100
	bcs   out          ; if ++numsamp < 100, skip

	lded  bins +  0
	sted  bins + 32    ; bins[16] = bins[0], bins[17] = bins[1]
	lded  bins +  4
	sted  bins + 36    ; bins[18] = bins[2], bins[19] = bins[3]

	clrw  0,z          ; max = 0
L1
	ldd   0,x
	addd  2,x
	addd  4,x
	addd  6,x
	addd  8,x          ; sum = sigma p [0 ... 4]

	cpd   0,z          ; > max ?
	bls   L2           ; lower or same
	std   0,z          ; max = sum
	txy                ; best in IY
L2
	aix   #+2
	cpx   # bins + 32
	bcs   L1           ; do while p < &bins[16]

	ldx   0,z          ; max
	beq   out          ; max 0 ? huh ?

	ldd   2,y          ; sum = best[1]
	addd  4,y
	addd  4,y          ; += best[2] * 2
	addd  6,y
	addd  6,y
	addd  6,y          ; += best[3] * 3
	addd  8,y
	addd  8,y
	addd  8,y
	addd  8,y          ; += best[4] * 4
	lde   # 45
	emul               ; sum *= 45     E * D to E:D
	ediv               ; sum /= max    E:D / IX to IX, rem in D

	tyd                ; best
	subd  # bins       ; -= bins
	lsrd               ; >>= 1, turn to index of best
	lde   # 45
	emul               ; *= 45 (fits in D)
	txe                ; sum, the offset inside best[]
	ade                ; offset += index is result in halfdegrees
	lsre               ; to degrees
	cpe   # 360
	bcs   L4
	sube  # 360        ; stay in 0 ... 359
L4
	ste   avg          ; new result

	clrd               ; bzero bins and numsamp = 0
	clre
	std   numsamp
	sted  bins +  0    ; bins[0] = bins[1] = 0
	sted  bins +  4
	sted  bins +  8
	sted  bins + 12
	sted  bins + 16
	sted  bins + 20
	sted  bins + 24
	sted  bins + 28    ; bins[14] = bins[15] = 0
out
	ldd   avg          ; kind of silly, but keep returning the average

	ais   #+2
	pulm  z
	rts

